% File "simvars.tu".
%
% Written by Phil Edmonds, March 97.
%
% This module contains parameters to change the behaviour of the simulation.
% Many of the classes import this module.
%
%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

unit
module SimVar

    export MAXTIME, HERBS_TO_START,
        W_MAX_X, W_MAX_Y, W_TERRAIN_SIZE,
        PLAIN_ENERGY, MOUNTAIN_ENERGY, PLAIN_RESISTANCE, MOUNTAIN_RESISTANCE,
        H_COST_PER_MOVE, H_SPEED,
        H_MAX_ENERGY, H_MIN_ENERGY

    % basic variables

    const MAXTIME := 100 %        how long to simulate for
    const HERBS_TO_START := 2 %    initial number of herbivores


    % dimensions of the world, and size of a piece of terrain

    const W_MAX_X := 600 %         horizontal size
    const W_MAX_Y := 360 %         vertical size
    const W_TERRAIN_SIZE := 20 %   must be a common divisor of the dimensions

    % for Terrain and subclasses of Terrain

    const PLAIN_ENERGY := 10 %      energy to be had by eating on plains
    const MOUNTAIN_ENERGY := 0 %    energy to be had by eating in mountains
    const PLAIN_RESISTANCE := 1.0 % move at full speed on plains
    const MOUNTAIN_RESISTANCE := 0.20 % move at 20% speed in mountains
    
    % for Herbivores

    const H_COST_PER_MOVE := 5 %    energy it takes to move
    const H_SPEED := 20 %           how many pixels per move
    const H_MAX_ENERGY := 200 %     maximum energy attainable
    const H_MIN_ENERGY := 100 %     energy level where eating is required


end SimVar
